$(function(){

    // Сохраняем некоторые элементы в переменные для удобства

    var refreshButton = $('.title_2 img'),
        shoutboxForm = $('.shoutbox-form'),
        form = shoutboxForm.find('form'),
        closeForm = shoutboxForm.find('.shoutbox-form-write span'),
        keyElement = form.find('#shoutbox-key'),
        commentElement = form.find('#shoutbox-comment'),
        ul = $('ul.shoutbox-content');


    // Заменяем :) на смайлики-эмоджи:
    emojione.ascii = true;

    // Загружаем комментарии.
    load();
    
    // При отправке формы, если все заполнено, публикуем сообщение в базе данных
    
    var canPostComment = true;

    form.submit(function(e){
        e.preventDefault();

        if(!canPostComment) return;
        
        var key = keyElement.val().trim();
        var comment = commentElement.val().trim();

        if(key.length && comment.length && comment.length > 1 && comment.length < 2048) {
        
            publish(key,comment);

            // Prevent new shouts from being published

            canPostComment = false;

            // Allow a new comment to be posted after 5 seconds
            setTimeout(function(){
                canPostComment = true;
            }, 5000);

        }

    });
    
    // Переключаем видимость формы.
    
    shoutboxForm.on('click', '.shoutbox-form-write', function(e){
        
        if(form.is(':visible')) {
            formClose();
        } else {
            formOpen();
        }
        
    });
    
    // При клике на кнопку REPLY (Ответить) происходит добавление в текстовое поле имени человека, которому вы хотели бы ответить.
    
    ul.on('click', '.shoutbox-comment-reply', function(e){
        
        var replyName = $(this).data('name');
        var user_id = $(this).data('user_id');
        
        formOpen();
        commentElement.val('[u='+user_id+']'+replyName+'[/u], ').focus();

    });
    
    // При клике на кнопку «Обновить» происходит срабатывание функции load
    
    var canReload = true;

    refreshButton.click(function(){

        if(!canReload) return false;
        
        load();
        canReload = false;

        // Разрешаем дополнительные перезагрузки через 3 секунды
        setTimeout(function(){
            canReload = true;
        }, 3000);
    });

    // Автоматически обновляем сообщения каждые 6 секунд
    setInterval(load, 6000);


    function formOpen(){
        
        if(form.is(':visible')) return;

        form.slideDown();
        closeForm.fadeIn();
    }

    function formClose(){

        if(!form.is(':visible')) return;

        form.slideUp();
        closeForm.fadeOut();
    }

    // Изменяем номер страницы в адресной строке без перезагрузки страницы

    function setAttr(prmName,val){
        var res = '';
        var d = location.href.split("#")[0].split("?");
        var base = d[0];
        var query = d[1];
        if(query) {
            var params = query.split("&");
            for(var i = 0; i < params.length; i++) {
                var keyval = params[i].split("=");
                if(keyval[0] != prmName) {
                    res += params[i] + '&';
                }
            }
        }
        res += prmName + '=' + val;
        window.history.pushState(null, null, base + '?' + res);
        return false;
    }

    // Сохраняем сообщение в базе данных
    
    function publish(key,comment){
    
        $.post('publish.php', {key: key, message: comment}, function(){

            setAttr('page','1')
            document.getElementById('pageshidden').style.display = 'block';
            document.getElementById('pages').style.display = 'none';
            document.getElementById('page').dataset.page = '1';
            commentElement.val("");
            load();
        });

    }
    
    // Получаем последние сообщения
    
    function load(){
        var selection = document.getElementById("selection").dataset.selection
        $.getJSON('/modules/guestbook/load.php?selection=' + selection, function(data) {
            appendComments(data);
        });
    }
    
    // Обрабатываем массив с сообщениями в виде HTML
    //<span style="float: right;" class="shoutbox-comment-delete" data-id="' + d.id + '" data-user_id="' + d.user_id + '"><img src="/App_Themes/global/img/trash.svg" style="width:20px;" class="hh" title="Удалить"></span>
    function appendComments(data) {

        ul.empty();
        data.forEach(function(d){
            ul.append('<li>'+
                '<span class="shoutbox-username">' + d.name + '</span>' +
						 '<div class="shoutbox-group">' + d.group + '</div>' +
                '<p class="shoutbox-comment">' + emojione.toImage(d.text) + '</p>'+
                '<div class="shoutbox-comment-details"><span id="reply" class="shoutbox-comment-reply" data-name="' + d.nick + '" data-user_id="' + d.user_id + '">Ответить</span>'+
                '<span class="shoutbox-comment-ago">' + d.createdAt + '</span></div>'+
            '</li>');
        });

    }

});